*!* 2019 05 26 GLS
*!****************
*!* Machine I7-4510U 2Ghz -8 GO RAM, disque SSD, ANTIVIRUS DESACTIVE
********************************************************************
********************************************************************
********************************************************************

*!* Tester pour dterminer s'il y a intrt  utiliser le prfixe de nommage m. dans le code source de Visual Foxpro 9
*!********************************************************************************************************************
*!* 1 Utiliser le prfixe m. de nommage des variables lues est-ce utile ?
*!* 2 Utiliser le prfixe m. de nommage des variables affectes est-ce utile ?
*!* 3 Utiliser le prfixe m. de nommage des proprits lues d'objets est-ce utile ?

*!* Tester pour dterminer s'il y a intrt  utiliser les instructions mono-ligne et lieu et place d'instructions multi-lignes dans le code source de Visual Foxpro 9
*!********************************************************************************************************************************************************************
*!* 4 Remplacer du code sur plusieurs lignes de commandes par du code avec instruction mono-ligne de commande au rendu similaire est-ce utile ?

*!* Tester pour dterminer s'il y a intrt  utiliser les dclarations LOCAL de variables versus pas de dclaration pralable de variables dans le code source de Visual Foxpro 9
*!********************************************************************************************************************************************************************************
*!* 5 Utiliser les dclarations LOCAL de variables versus pas de dclaration de variables est-ce utile ?

*!* Tester pour dterminer s'il y a intrt  utiliser les affectations de proprites d'un objet dans un WITH .. ENDWITH versus sans with .. endwith  dans le code source de Visual Foxpro 9
*!*******************************************************************************************************************************************************************************************
*!* 6 Utiliser les affectations de proprites d'un objet dans un WITH .. ENDWITH est-ce utile ?

*!* Tester s'il y a intrt  utiliser un return lors de l'affectations de proprites d'un objet dans un WITH .. ENDWITH  dans le code source de Visual Foxpro 9
*!***************************************************************************************************************************************************************
* 7 Utiliser un RETURN dans les affectations de proprites d'un objet par WITH .. ENDWITH est-ce possible ?

*!* Tester s'il y a intrt  utiliser VARTYPE() versus TYPE() pour valuer le type d'un objet
*!********************************************************************************************
* 8 Utiliser VARTYPE() versus TYPE() est-ce utile ?

CLEAR ALL
DECLARE INTEGER QueryPerformanceCounter IN kernel32.DLL LONG @nDelai
SET PATH TO
*#DEFINE _CRLF CHR(13) + CHR(10)
PRIVATE cPath AS STRING, iDelaiMessage AS INTEGER, _CRLF AS STRING

_CRLF = CHR(13) + CHR(10)
cPath = ADDBS(SYS(5)+SYS(2003))
SET PATH TO (m.cPath) ADDITIVE
SET DEFAULT TO (m.cPath)
iDelaiMessage = 30

* 1 test prfixer le nommage des variables lues
=test_prefixe_lu()

* 2 test prfixer le nommage des variables affectes
=test_prefixe_affectee()

* 3 test prfixer le nommage des proprits lues d'objets
=test_prefixe_objet()

* 4 test de rapidit d'excution entre du code sur plusieurs lignes de commandes versus code instruction courte sur une seule ligne de commande
=test_mono_multi_ligne()

* 5 test d'utilisation des variables LOCAL, PRIVATE et sans dclaration pralable
=test_declaration_variable()

* 6 test d'utilisation WITH .. ENDWITH
=test_with_endwith()

* 7 test d'utilisation RETURN dans un WITH .. ENDWITH
=test_with_return_endwith()

* 8 test d'utilisation VARTYPE() versus TYPE()
=test_type_versus_vartype()

SET SYSMENU TO DEFAULT
CANCEL

* Tester l'utilisation du prfixe m. de nommage des variables lues
PROCEDURE test_prefixe_lu
	*!*	1 - crer une table atf2019_2 colonne var2 c(40) && sert  dmontrer que les alias non courant n'impactent pas l'utilisation avec et sans prfixe de nommage de variables lues
	*!*	2 - insrer dans la table atf2019_2 'ma table2.variable 2'
	*!*	3 - crer une table atf2019_1 colonne var1 c(40), var2 c(40) && sert  dmontrer que l'alias courant impacte l'utilisation avec et sans prfixe de nommage de variables lues
	*!*	4 - insrer dans la table atf2019_1 'ma table.variable 1', 'ma table.variable 2'
	*!*	5 - excuter, mesurer sa vitesse et vrifier le rsultat d'une concatnation des variables lues et nommes sans prfixe var1, var2 dans une chaine de caractres dans une boucle m.iBoucle
	*!*	6 - excuter, mesurer sa vitesse et vrifier le rsultat d'une concatnation des variables lues et nommes avec prfixe m. m.var1, m.var2 dans une chaine de caractres dans une boucle m.iBoucle
	*!* WAIT 'Test prfixe nommage variable lue' WINDOWS NOWAIT && ATTENTION WAIT WINDOWS NOWAIT LANCE UN GARBAGE COLLECTOR DANS VFP
	=SYS(1104) && garbage collector
	? 'Test prfixe nommage variable lue dbut :' + TTOC(DATETIME())
	LOCAL cChaine1 AS STRING;
		, cChaine2 AS STRING;
		, cMessage1 AS STRING;
		, cMessage2 AS STRING;
		, cMessage AS STRING;
		, cVar1 AS STRING;
		, cVar2 AS STRING;
		, cVar3 AS STRING;
		, cVar4 AS STRING;
		, cFileCoverage AS STRING;
		, iDureinstruction1 AS NUMBER;
		, iDureinstruction2 AS NUMBER;
		, iDuree1 AS NUMBER;
		, iDuree2 AS NUMBER;
		, iBoucle AS INTEGER;
		, i AS INTEGER

	iBoucle = 10000
	var1 = PADR('ma variable mmoire 1', 40, SPACE(1))
	var2 = PADR('ma variable mmoire 2', 40, SPACE(1))
	var3 = PADR('ma m.variable mmoire 3', 40, SPACE(1))
	var4 = PADR('ma m.variable mmoire 4', 40, SPACE(1))
	STORE '' TO cMessage1, cMessage2, cChaine1, cChaine2
	STORE 0 TO iDureeInstruction1, iDureeInstruction2, iDuree1, iDuree2

	* Cration d'une table comportant des colonnes au nom identique  celui d'une des 4 variables var1  var4
	* Cette table sert  ventuellement dmontrer que sansprfixe c'est le contenu de la table qui est lu et non celui de la variable
	IF FILE('atf2019_1.dbf')
		USE IN SELECT('atf2019_1')
		DELETE FILE ('atf2019_1.dbf')
	ENDIF
	CREATE TABLE 'atf2019_1' FREE (var1 c(40), var2 c(40))
	INSERT INTO  atf2019_1 (var1, var2) VALUES ('ma table.variable 1', 'ma table.variable 2')

	FOR i = 1 TO m.iBoucle
		* Test sans prfixe de nommage des variables lues
		=QueryPerformanceCounter(@m.iDureeInstruction1)
		cChaine1 = '  var1: ' + var1 + m._CRLF + '  var2: ' + var2
		=QueryPerformanceCounter(@m.iDureeInstruction2)
		iDuree1 = m.iDuree1 + (m.iDureeInstruction2 - m.iDureeInstruction1)

		* Test avec prfixe m. de nommage des variables lues
		=QueryPerformanceCounter(@m.iDureeInstruction1)
		cChaine2 = 'm.var3 ' + m.var3 + m._CRLF + 'm.var4: ' + m.var4
		=QueryPerformanceCounter(@m.iDureeInstruction2)
		iDuree2 = m.iDuree2 + (m.iDureeInstruction2 - m.iDureeInstruction1)
	ENDFOR
	cMessage1 = 'Dure sans prfixe de nommage de variables lues dure: ' + ALLTRIM(STR(m.iDuree1  / m.iBoucle, 10, 3)) + ' s' + m._CRLF + 'cChaine:' + m._CRLF + m.cChaine1 + m._CRLF + 'LEN : ' + ALLTRIM(STR(LEN(m.cChaine1)))
	cMessage2 = 'Dure avec prfixe m. de nommage de variables lues dure: ' + ALLTRIM(STR(m.iDuree2 / m.iBoucle, 10, 3)) + ' s' + m._CRLF + 'cChaine2:' + m._CRLF + m.cChaine2 + m._CRLF + 'LEN : ' + ALLTRIM(STR(LEN(m.cChaine2)))

	* Fermeture des tables
	USE IN SELECT('atf2019_1')
	DELETE FILE ('atf2019_1.dbf')

	cMessage = UPPER("Test d'utilisation du prfixe m. dans le nommage de variables lues:") + m._CRLF + m._CRLF + m.cMessage1 + m._CRLF + m._CRLF + m.cMessage2
	? 'Test prfixe nommage variable lue fin :' + TTOC(DATETIME())
	=MESSAGEBOX(m.cMessage, 0+64, 'AtoutFox2019', m.iDelaiMessage)
	CLEAR
	* CONCLUSION
	************
	* Prfixer le nommage des variables avec m. (y compris THIS et THISFORM) est obligatoire lorsque l'alias (table, curseur, vue) courant contient un nom de colonne identique  la variable employe, sinon c'est le contenu de la colonne qui est lu.
	* Lorsqu'il n'a pas dans l'alias courant un nom de colonne identique au nom d'une variable, la lecture prfixe m. de cette variable est plus rapide que celle non prefixe.
ENDPROC

* Tester l'utilisation du prfixe m. de nommage des variables affectes
PROCEDURE test_prefixe_affectee()
	*!*	1 - Test utilisation variables affectes avec prefixe m. boucl m.iBoucle fois sur des variables diffrentes pour viter les effets des caches de Foxpro
	*!* WAIT 'Test prfixe nommage variable affecte' WINDOWS NOWAIT
	=SYS(1104) && garbage collector
	? 'Test prfixe nommage variable affecte dbut :' + TTOC(DATETIME())
	LOCAL cMessage1 AS STRING;
		, cMessage2 AS STRING;
		, cMessage AS STRING;
		, cVar1 AS STRING;
		, cVar2 AS STRING;
		, iBoucle AS INTEGER;
		, cChaine1 AS STRING;
		, cChaine2 AS STRING;
		, iDureinstruction1 AS NUMBER;
		, iDureinstruction2 AS NUMBER;
		, iDuree1 AS NUMBER;
		, iDuree2 AS NUMBER;
		, i AS INTEGER

	iBoucle = 10000
	cVar1 = PADR('ma variable mmoire 1', 40, SPACE(1))
	cVar2 = PADR('ma variable mmoire 2', 40, SPACE(1))
	STORE '' TO cMessage1, cMessage2, cChaine1, cChaine2
	STORE 0 TO iDureeInstruction1, iDureeInstruction2, iDuree1, iDuree2
	FOR i = 1 TO m.iBoucle
		* Test sans prfixe de nommage des variables affectes
		=QueryPerformanceCounter(@m.iDureeInstruction1)
		cChaine1 = m.cChaine1 + '  cVar1: ' + m.cVar1 + m._CRLF + '  cVar2: ' + m.cVar2
		=QueryPerformanceCounter(@m.iDureeInstruction2)
		iDuree1 = m.iDuree1 + (m.iDureeInstruction2 - m.iDureeInstruction1)

		* Test avec prfixe de nommage des variables affectes
		=QueryPerformanceCounter(@m.iDureeInstruction1)
		m.cChaine2 = m.cChaine2 + 'm.cVar1: ' + m.cVar1 + m._CRLF + 'm.cVar2: ' + m.cVar2
		=QueryPerformanceCounter(@m.iDureeInstruction2)
		iDuree2 = m.iDuree2 + (m.iDureeInstruction2 - m.iDureeInstruction1)
	ENDFOR
	* Test avec prfixe m. de nommage des variables lues et affectes
	cMessage2 = 'Dure avec prfixe de nommage de variables affectes dure: ' + ALLTRIM(STR(m.iDuree2 / m.iBoucle, 10, 3)) + ' s' &&+ m._CRLF + 'cChaine:' + m._CRLF + m.cChaine + m._CRLF + 'LEN : ' + ALLTRIM(STR(LEN(m.cChaine)))
	* Test sans prfixe de nommage des variables affectes (uniquement prfixe m. de nommage des variables lues)
	cMessage1 = 'Dure sans prfixe de nommage de variables affectes dure: ' + ALLTRIM(STR(m.iDuree1 / m.iBoucle, 10, 3)) + ' s' &&+ m._CRLF + 'cChaine:' + m._CRLF + m.cChaine + m._CRLF + 'LEN : ' + ALLTRIM(STR(LEN(m.cChaine)))

	cMessage = UPPER("Test d'utilisation du prfixe m. dans le nommage de variables affectes:") + m._CRLF + m._CRLF + m.cMessage1 + m._CRLF + m._CRLF + m.cMessage2
	=MESSAGEBOX(m.cMessage, 0+64, 'AtoutFox2019', m.iDelaiMessage)
	CLEAR
	* CONCLUSION
	************
	* Hormis une volont de logique de cohrence de nommage avec prfixe m. de nommage entre variables lues et variables affectes, il n'y a pas de bnfice significatif d'efficacit en vitesse  prfixer dans son code les variables affectes.
ENDPROC

* Tester l'utilisation du prfixe m. de nommage des proprits lues d'objets
PROCEDURE test_prefixe_objet
	*!*	1 - crer une table oObjet colonne var1 c(40), var2 c(40), this c(40), thisform c(40) && sert  dmontrer que seul l'alias courant impacte l'utilisation avec et sans prfixe de nommage de proprits lues d'objets
	*!*	2 - insrer dans la table oObjet 'ma table.propriete 1', 'ma table.propriete 2', 'ma table.proprit THIS', 'ma table.proprit THISFORM'
	*!*	3 - excuter, mesurer sa vitesse et vrifier le rsultat d'une concatnation de proprits d'objets lues et nommes sans prfixe dans une chaine de caractres dans une boucle m.iBoucle
	*!*	4 - excuter, mesurer sa vitesse et vrifier le rsultat d'une concatnation de proprits d'objets lues et nommes avec prfixe m. de nommage dans une chaine de caractres dans une boucle m.iBoucle
	*!*	5 - excuter, mesurer sa vitesse et vrifier le rsultat d'une concatnation de proprits d'objets lues depuis WITH .. ENDWITH dans une chaine de caractres dans une boucle m.iBoucle
	=SYS(1104) && garbage collector
	? 'Test prfixe nommage objet.proprit lue dbut :' + TTOC(DATETIME())
	LOCAL cChaine1 AS STRING;
		, cChaine2 AS STRING;
		, cChaine3 AS STRING;
		, cMessage1 AS STRING;
		, cMessage2 AS STRING;
		, cMessage3 AS STRING;
		, cMessage AS STRING;
		, oObjet AS OBJECT;
		, oObjet2 AS OBJECT;
		, oObjet3 AS OBJECT;
		, iDureinstruction1 AS NUMBER;
		, iDureinstruction2 AS NUMBER;
		, iDuree1 AS NUMBER;
		, iDuree2 AS NUMBER;
		, iDuree3 AS NUMBER;
		, iBoucle AS INTEGER;
		, i AS INTEGER

	IF FILE('oObjet.dbf')
		USE IN SELECT('oObjet')
		DELETE FILE ('oObjet.dbf')
	ENDIF
	CREATE TABLE 'oObjet' FREE (var1 c(40), var2 c(40), THIS c(40), THISFORM c(40))
	INSERT INTO  oObjet (var1, var2, THIS, THISFORM) VALUES ('ma table.propriete 1', 'ma table.propriete 2', 'ma table.proprit THIS', 'ma table.proprit THISFORM')

	iBoucle = 10000
	STORE '' TO cMessage1, cMessage2, cMessage3, cChaine1, cChaine2, cChaine3
	STORE 0 TO iDureeInstruction1, iDureeInstruction2, iDuree1, iDuree2, iDuree3
	oObjet = NEWOBJECT('empty')
	=ADDPROPERTY(m.oObjet,'var1', '')
	=ADDPROPERTY(m.oObjet,'var2', '')
	=ADDPROPERTY(m.oObjet,'this', '')
	=ADDPROPERTY(m.oObjet,'thisform', '')
	WITH oObjet
		.var1 = PADR('ma propriet mmoire objet.var1', 40, SPACE(1))
		.var2 = PADR('ma propriet mmoire objet.var2', 40, SPACE(1))
		.THIS = PADR('ma propriet mmoire objet.THIS', 40, SPACE(1))
		.THISFORM = PADR('ma propriet mmoire objet.THISFORM', 40, SPACE(1))
	ENDWITH
	FOR i = 1 TO m.iBoucle
		* Test sans prfixe de nommage des proprits lues des objets
		=QueryPerformanceCounter(@m.iDureeInstruction1)
		cChaine1 = ALLTRIM(STR(m.i)) + '    oObjet.var1: ' + oObjet.var1;
			+ m._CRLF + '  oObjet.var2: ' + oObjet.var2;
			+ m._CRLF + '  oObjet.THIS: ' + oObjet.THIS;
			+ m._CRLF + '  oObjet.THISFORM: ' + oObjet.THISFORM
		=QueryPerformanceCounter(@m.iDureeInstruction2)
		iDuree1 = m.iDuree1 + (m.iDureeInstruction2 - m.iDureeInstruction1)

		* Test avec prfixe de nommage des proprits lues des objets
		=QueryPerformanceCounter(@m.iDureeInstruction1)
		cChaine2 = ALLTRIM(STR(m.i)) + '  m.oObjet.var1: ' + m.oObjet.var1;
			+ m._CRLF + 'm.oObjet.var2: ' + m.oObjet.var2;
			+ m._CRLF + 'm.oObjet.THIS: ' + m.oObjet.THIS;
			+ m._CRLF + 'm.oObjet.THISFORM: ' + m.oObjet.THISFORM
		=QueryPerformanceCounter(@m.iDureeInstruction2)
		iDuree2 = m.iDuree2 + (m.iDureeInstruction2 - m.iDureeInstruction1)

		* Test avec utilisation WITH ENDWITH des proprits lues des objets
		=QueryPerformanceCounter(@m.iDureeInstruction1)
		WITH oObjet
			cChaine3 = ALLTRIM(STR(m.i)) + ' .var1: ' + .var1;
				+ m._CRLF + '.var2: ' + .var2;
				+ m._CRLF + '.THIS: ' + .THIS;
				+ m._CRLF + '.THISFORM: ' + .THISFORM
		ENDWITH
		=QueryPerformanceCounter(@m.iDureeInstruction2)
		iDuree3 = m.iDuree3 + (m.iDureeInstruction2 - m.iDureeInstruction1)
	ENDFOR
	cMessage1 = "Dure avec prfixe m. de nommage de proprits lues d'objets dure: " + ALLTRIM(STR(m.iDuree1  / m.iBoucle, 10, 3)) + ' s' + m._CRLF + 'cChaine:' + m._CRLF + m.cChaine1 + m._CRLF + 'LEN : ' + ALLTRIM(STR(LEN(m.cChaine1)))
	cMessage2 = "Dure sans prfixe de nommage de proprits lues d'objets dure: " + ALLTRIM(STR(m.iDuree2  / m.iBoucle, 10, 3)) + ' s' + m._CRLF + 'cChaine2:' + m._CRLF + m.cChaine2 + m._CRLF + 'LEN : ' + ALLTRIM(STR(LEN(m.cChaine2)))
	cMessage3 = "Dure avec WITH ENDWITH de proprits lues d'objets dure: " + ALLTRIM(STR(m.iDuree3 / m.iBoucle, 10, 3)) + ' s' + m._CRLF + 'cChaine3:' + m._CRLF + m.cChaine3 + m._CRLF + 'LEN : ' + ALLTRIM(STR(LEN(m.cChaine3)))
	* Fermeture des tables
	USE IN SELECT('oObjet')
	DELETE FILE ('oObjet.dbf')

	cMessage = UPPER("Test utilisation du prfixe m. de nommage de proprits lues d'objets:") + m._CRLF + m._CRLF + m.cMessage1 + m._CRLF + m._CRLF + m.cMessage2 + m._CRLF + m._CRLF + m.cMessage3
	=MESSAGEBOX(m.cMessage, 0+64, 'AtoutFox2019', m.iDelaiMessage)
	CLEAR
	* CONCLUSION
	************
	* Le prfixe par m. du nommage des proprits des objets est ncessaire comme pour celui des variables pour viter la confusion entre l'utilisation du contenu d'une variable et l'utilisation du contenu d'une colonnede mme nom dans l'alias courant.
	* On peut constater qu' longueur identique de donnes  concatner dans une chaine, la vitesse de concatnation est quasiment identique lorsque les noms des proprits d'un objet sont prfixs par m.
	* L'utilisation de WITH ENDWITH pour accder  des proprits d'objet lu n'a pas d'influence sur la rapidit de concatnation
ENDPROC

* Tester et vrifier la rapidit d'excution entre du code sur plusieurs lignes de commandes versus code avec instruction au rendu similaire mono-ligne de commande
PROCEDURE test_mono_multi_ligne
	*!*	1 - excuter un do case sur 5 cas qui affecte une valeur (N du case) dans une variable et mesurer le temps d'excution
	*!*	2 - excuter un icase sur 5 cas qui affecte une valeur (N du icase) dans une variable et mesurer le temps d'excution
	*!*	3 - excuter un if else endif qui affecte une valeur dans une variable et mesurer le temps d'excution
	*!*	4 - excuter un IIF() qui affecte une valeur dans une variable et mesurer le temps d'excution
	=SYS(1104) && garbage collector
	? 'Test instruction multi-lignes versus instruction mono-ligne dbut :' + TTOC(DATETIME())
	LOCAL cChaine1 AS STRING;
		, cChaine2 AS STRING;
		, cChaine3 AS STRING;
		, cChaine4 AS STRING;
		, cMessage1 AS STRING;
		, cMessage2 AS STRING;
		, cMessage3 AS STRING;
		, cMessage4 AS STRING;
		, cMessage AS STRING;
		, iValCase AS INTEGER;
		, iDureinstruction1 AS NUMBER;
		, iDureinstruction2 AS NUMBER;
		, iDuree1 AS NUMBER;
		, iDuree2 AS NUMBER;
		, iDuree3 AS NUMBER;
		, iDuree4 AS NUMBER;
		, iBoucle AS INTEGER;
		, iValCase AS INTEGER;
		, i AS INTEGER

	iBoucle = 10000
	iValCase = 1
	STORE '' TO cMessage1, cMessage2, cMessage3, cMessage4, cChaine1, cChaine2, cChaine3, cChaine4
	STORE 0 TO iDureeInstruction1, iDureeInstruction2, iDuree1, iDuree2, iDuree3, iDuree4

	FOR i = 1 TO m.iBoucle
		* Test vitesse excution do case
		=QueryPerformanceCounter(@m.iDureeInstruction1)
		DO CASE
			CASE m.iValCase = 1
				cChaine1 = ALLTRIM(STR(m.iValCase))

			CASE m.iValCase = 2
				cChaine1 = ALLTRIM(STR(m.iValCase))

			CASE m.iValCase = 3
				cChaine1 = ALLTRIM(STR(m.iValCase))

			CASE m.iValCase = 4
				cChaine1 = ALLTRIM(STR(m.iValCase))

			CASE m.iValCase = 5
				cChaine1 = ALLTRIM(STR(m.iValCase))

			CASE m.iValCase = 6
				cChaine1 = ALLTRIM(STR(m.iValCase))

			CASE m.iValCase = 7
				cChaine1 = ALLTRIM(STR(m.iValCase))

			CASE m.iValCase = 8
				cChaine1 = ALLTRIM(STR(m.iValCase))

			CASE m.iValCase = 9
				cChaine1 = ALLTRIM(STR(m.iValCase))

			CASE m.iValCase = 10
				cChaine1 = ALLTRIM(STR(m.iValCase))

			OTHERWISE
				cChaine = ''
		ENDCASE
		=QueryPerformanceCounter(@m.iDureeInstruction2)
		iDuree1 = m.iDuree1 + (m.iDureeInstruction2 - m.iDureeInstruction1)

		* Test vitesse excution icase
		=QueryPerformanceCounter(@m.iDureeInstruction1)
		cChaine2 = ICASE(;
			m.iValCase = 1;
			, ALLTRIM(STR(m.iValCase));
			, m.iValCase = 2;
			, ALLTRIM(STR(m.iValCase));
			, m.iValCase = 3;
			, ALLTRIM(STR(m.iValCase));
			, m.iValCase = 4;
			, ALLTRIM(STR(m.iValCase));
			, m.iValCase = 5;
			, ALLTRIM(STR(m.iValCase));
			, m.iValCase = 6;
			, ALLTRIM(STR(m.iValCase));
			, m.iValCase = 7;
			, ALLTRIM(STR(m.iValCase));
			, m.iValCase = 8;
			, ALLTRIM(STR(m.iValCase));
			, m.iValCase = 9;
			, ALLTRIM(STR(m.iValCase));
			, m.iValCase = 10;
			, ALLTRIM(STR(m.iValCase));
			, '';
			)
		=QueryPerformanceCounter(@m.iDureeInstruction2)
		iDuree2 = m.iDuree2 + (m.iDureeInstruction2 - m.iDureeInstruction1)

		* Test vitesse excution if else endif
		=QueryPerformanceCounter(@m.iDureeInstruction1)
		IF m.iValCase = 1
			cChaine3 = '1'
		ELSE
			cChaine3 = ALLTRIM(STR(m.iValCase))
		ENDIF
		=QueryPerformanceCounter(@m.iDureeInstruction2)
		iDuree3 = m.iDuree3 + (m.iDureeInstruction2 - m.iDureeInstruction1)

		* Test vitesse excution iif()
		=QueryPerformanceCounter(@m.iDureeInstruction1)
		=QueryPerformanceCounter(@m.iDureeInstruction2)
		iDuree4 = m.iDuree4 + (m.iDureeInstruction2 - m.iDureeInstruction1)
	ENDFOR
	cMessage1 = "Dure instruction multi-lignes DO CASE..ENDCASE: " + ALLTRIM(STR(m.iDuree1 / m.iBoucle, 10, 3)) + ' s' + m._CRLF
	cMessage2 = "Dure instruction mono-ligne ICASE(): " + ALLTRIM(STR(m.iDuree2 / m.iBoucle, 10, 3)) + ' s' + m._CRLF
	cMessage3 = "Dure instruction IF ELSE ENDIF: " + ALLTRIM(STR(m.iDuree3 / m.iBoucle, 10, 3)) + ' s' + m._CRLF
	cMessage4 = "Dure instruction IIF(): " + ALLTRIM(STR(m.iDuree4 / m.iBoucle, 10, 3)) + ' s' + m._CRLF

	cMessage = UPPER("Test utilisation instruction mono-ligne versus instruction multi-lignes:") + m._CRLF + m._CRLF + m.cMessage1 + m._CRLF + m._CRLF + m.cMessage2 + m._CRLF + m._CRLF + m.cMessage3 + m._CRLF + m._CRLF + m.cMessage4
	? 'Test instruction multi-lignes versus instruction mono-ligne fin :' + TTOC(DATETIME())
	=MESSAGEBOX(m.cMessage, 0+64, 'AtoutFox2019', m.iDelaiMessage)
	CLEAR
	* CONCLUSION
	************
	* Il est fortement utile d'utiliser les instructions mono-ligne en lieu et place d'instructions multi-lignes similaires.
	* Le gain en vitesse est trs significatif (de 30%  60% plus rapide en excution pour les instructions mono-ligne par rapport aux instructions aux rsultats identiques en multi-lignes)
ENDPROC

* test d'utilisation des variables LOCAL, PRIVATE et sans dclaration pralable
PROCEDURE test_declaration_variable
	*!*	1 - affecter une valeur  une variable sans dclaration initiale puis appeler une procdure enfant
	* utilisant et affectant le mme nom de variable sans dclaration pralable
	*!* 2 - affecter une valeur  une variable sans dclaration initiale puis appeler une procdure enfant
	* utilisant et affectant le mme nom de variable pralablement dclare LOCAL dans la procdure enfant
	*!* 3 - affecter une valeur  une variable sans dclaration initiale puis appeler une procdure enfant
	* utilisant et affectant le mme nom de variable pralablement PRIVATE dans la procdure enfant
	=SYS(1104) && garbage collector
	? 'Test utilisation des variables LOCAL, PRIVATE et sans dclaration pralable dbut :' + TTOC(DATETIME())
	LOCAL cMessage AS STRING;
		, cMessage1 AS STRING;
		, cMessage2 AS STRING;
		, cMessage3 AS STRING;
		, cOrig AS STRING;
		, cVariable AS STRING

	cVariable = '<cVariable non dclare affecte depuis programme appelant>'
	cOrig = m.cVariable
	=proc_variablenondeclare()
	cMessage1 = UPPER("Variable non dclare et appel programme enfant utilisant mme nom de variable non dclare:") + m._CRLF + 'Avant appel procdure enfant: ' + m._CRLF + m.cOrig + m._CRLF + m._CRLF + 'Modifie par procdure enfant: ' + m._CRLF + m.cVariable

	cVariable = m.cOrig && remise dans l'tat original
	=proc_idemvariabledeclarelocal()
	cMessage2 = UPPER("Variable non dclare et appel programme enfant utilisant mme nom de variable localise:") + m._CRLF + 'Avant appel procdure enfant: ' + m._CRLF + m.cOrig + m._CRLF + m._CRLF + 'Non modifie aprs appel procdure enfant: ' + m._CRLF + m.cVariable

	cVariable = m.cOrig && remise dans l'tat original
	=proc_idemvariabledeclareprivate()
	cMessage3 = UPPER("Variable non dclare et appel programme enfant utilisant mme nom de variable privatise:") + m._CRLF + 'Avant appel procdure enfant: ' + m._CRLF + m.cOrig + m._CRLF + m._CRLF + 'Non modifie aprs appel procdure enfant: ' + m._CRLF + m.cVariable

	cMessage = UPPER("Test utilisation variable dclare versus variable non dclare:") + m._CRLF + m._CRLF + m.cMessage1 + m._CRLF + m._CRLF + m.cMessage2 + m._CRLF + m._CRLF + m.cMessage3
	? 'Test utilisation des variables LOCAL, PRIVATE et sans dclaration pralable fin :' + TTOC(DATETIME())
	=MESSAGEBOX(m.cMessage, 0+64, 'AtoutFox2019', m.iDelaiMessage)
	CLEAR
	* CONCLUSION
	************
	* Dans une procdure / programme une variable utilise sans dclaration pralable sera visible et utilisable depuis toute procdure enfant car considre comme variable PRIVATE
	* Dans un programme enfant lorsqu'une variable est dclare, la variable nomme  l'identique dans le programme parent ne sera pas modifiable ni utilisable dans le programme enfant
	* Il est vivement conseill de dclarer LOCAL toute variable d'une procdure /  programme pour viter les erreurs d'affectation (il est prfrable d'viter une interaction forte entre les diffrentes procdures / mthodes / fonctions)
	* Si une procdure / programme enfant doit pouvoir connaitre le contenu d'une variable localise appartenant au programme parent, alors la variable parent doit tre passe  la mthode / programme enfant par valeur =proc_enfant(m.cVariable)
	* Si une procdure / programme enfant doit pouvoir connaitre et modifier le contenu d'une variable localise appartenant au programme parent, alors la variable parent doit tre passe  la mthode / programme enfant par rfrence =proc_enfant(@m.cVariable)
ENDPROC

PROCEDURE proc_variablenondeclare
	cVariable = '<cVariable non dclare affecte depuis programme enfant>'
	=procbis_variablenondeclare()
ENDPROC

PROCEDURE procbis_variablenondeclare
	cVariable = '<cVariable non dclare affecte depuis programme bis enfant>'
ENDPROC

PROCEDURE proc_idemvariabledeclarelocal
	LOCAL cVariable AS STRING

	cVariable = '<cVariable dclare LOCAL affecte depuis programme enfant>'
ENDPROC

PROCEDURE proc_idemvariabledeclareprivate
	PRIVATE cVariable

	cVariable = '<cVariable dclare PRIVATE affecte depuis programme enfant>'
	=procbis_variablenondeclare()
ENDPROC

* Test d'utilisation du WITH .. ENDWITH pour affecter les proprites d'un objet
PROCEDURE test_with_endwith
	*!*	1 - Dclarer un objet et affecter une par une et ligne de commande par ligne de commande les proprites d'un objet. Boucler m.iBoucle fois  pour ce test
	*!*	2 - Dclarer un objet  l'identique du premier et affecter chaque proprites d'un objet dans un WITH .. ENDWITH. Boucler iBoucle fois  pour ce test
	=SYS(1104) && garbage collector
	? "Test utilisation d'un WITH ENDWITH pour affecter les proprites d'un objet dbut :" + TTOC(DATETIME())
	LOCAL cMessage AS STRING;
		, cMessage1 AS STRING;
		, cMessage2 AS STRING;
		, oObjet AS OBJECT;
		, iDureinstruction1 AS NUMBER;
		, iDureinstruction2 AS NUMBER;
		, iDuree1 AS NUMBER;
		, iDuree2 AS NUMBER;
		, iBoucle AS INTEGER;
		, i AS INTEGER

	iBoucle = 10000
	STORE '' TO cMessage1, cMessage2
	STORE 0 TO iDureeInstruction1, iDureeInstruction2, iDuree1, iDuree2
	* Initialisation de deux objets contenant chacun 15 proprites
	oObjet = NEWOBJECT('empty')
	FOR i = 1 TO 5
		=ADDPROPERTY(m.oObjet,'cvar' + ALLTRIM(STR(m.i)), '')
	ENDFOR
	FOR i = 1 TO 5
		=ADDPROPERTY(m.oObjet,'ivar' + ALLTRIM(STR(m.i)), 0)
	ENDFOR
	FOR i = 1 TO 5
		=ADDPROPERTY(m.oObjet,'lvar' + ALLTRIM(STR(m.i)), .F.)
	ENDFOR

	FOR i = 1 TO m.iBoucle
		* Test performance affectation proprit object avec WITH ENDWITH
		=QueryPerformanceCounter(@m.iDureeInstruction1)
		WITH oObjet
			.cVar1 = PADR('ma propriet objet.cvar1' + ' ' + ALLTRIM(STR(m.i)), 40, SPACE(1))
			.cVar2 = PADR('ma propriet objet.cvar2' + ' ' + ALLTRIM(STR(m.i)), 40, SPACE(1))
			.cVar3 = PADR('ma propriet objet.cvar3' + ' ' + ALLTRIM(STR(m.i)), 40, SPACE(1))
			.cVar4 = PADR('ma propriet objet.cvar4' + ' ' + ALLTRIM(STR(m.i)), 40, SPACE(1))
			.cvar5 = PADR('ma propriet objet.cvar5' + ' ' + ALLTRIM(STR(m.i)), 40, SPACE(1))
			.ivar1 = m.i
			.ivar2 = m.i + 1
			.ivar3 = m.i + 2
			.ivar4 = m.i + 3
			.ivar5 = m.i + 4
			.lvar1 = .F.
			.lvar2 = .T.
			.lvar3 = .F.
			.lvar4 = .T.
			.lvar5 = .F.
		ENDWITH
		=QueryPerformanceCounter(@m.iDureeInstruction2)
		iDuree1 = m.iDuree1 + (m.iDureeInstruction2 - m.iDureeInstruction1)

		* Test performance affectation proprit object sans WITH ENDWITH
		=QueryPerformanceCounter(@m.iDureeInstruction1)
		oObjet.cVar1 = PADR('ma propriet objet.cvar1' + ' ' + ALLTRIM(STR(m.i)), 40, SPACE(1))
		oObjet.cVar2 = PADR('ma propriet objet.cvar2' + ' ' + ALLTRIM(STR(m.i)), 40, SPACE(1))
		oObjet.cVar3 = PADR('ma propriet objet.cvar3' + ' ' + ALLTRIM(STR(m.i)), 40, SPACE(1))
		oObjet.cVar4 = PADR('ma propriet objet.cvar4' + ' ' + ALLTRIM(STR(m.i)), 40, SPACE(1))
		oObjet.cvar5 = PADR('ma propriet objet.cvar5' + ' ' + ALLTRIM(STR(m.i)), 40, SPACE(1))
		oObjet.ivar1 = m.i
		oObjet.ivar2 = m.i + 1
		oObjet.ivar3 = m.i + 2
		oObjet.ivar4 = m.i + 3
		oObjet.ivar5 = m.i + 4
		oObjet.lvar1 = .T.
		oObjet.lvar2 = .F.
		oObjet.lvar3 = .T.
		oObjet.lvar4 = .F.
		oObjet.lvar5 = .T.
		=QueryPerformanceCounter(@m.iDureeInstruction2)
		iDuree2 = m.iDuree2 + (m.iDureeInstruction2 - m.iDureeInstruction1)
	ENDFOR
	cMessage1 = "Dure affectation proprit oObjet avec WITH..ENDWITH: " + ALLTRIM(STR(m.iDuree1 / m.iBoucle, 10, 3)) + ' s' + m._CRLF
	cMessage2 = "Dure affectation proprit oObjet sans WITH..ENDWITH: " + ALLTRIM(STR(m.iDuree2 / m.iBoucle, 10, 3)) + ' s' + m._CRLF

	cMessage = UPPER("Test utilisation affectation proprites avec WITH .. ENDWITH:") + m._CRLF + m._CRLF + m.cMessage1 + m._CRLF + m._CRLF + m.cMessage2
	? "Test utilisation d'un WITH ENDWITH pour affecter les proprites d'un objet fin :" + TTOC(DATETIME())
	=MESSAGEBOX(m.cMessage, 0+64, 'AtoutFox2019', m.iDelaiMessage)
	CLEAR
	* CONCLUSION
	************
	* Il semble que l'utilisation du WITH .. ENDWITH n'apporte qu'une lgre augmentation de vitesse d'excution supplmentaire que confirme le manuel utilisateur de Foxpro
ENDPROC

* Test d'utilisation d'un RETURN dans WITH .. ENDWITH d'affectation des proprites d'un objet
PROCEDURE test_with_return_endwith
	=SYS(1104) && garbage collector
	? "Test utilisation d'un RETURN dans un WITH ENDWITH dbut :" + TTOC(DATETIME())
	LOCAL cMessage AS STRING;
		, cMessage1 AS STRING;
		, cMessage2 AS STRING;
		, oObjet AS OBJECT;
		, oObjet2 AS OBJECT;
		, cFileCoverage AS STRING;
		, iDureinstruction AS NUMBER;
		, iBoucle AS INTEGER

	cMessage1 = 'OK'
	TRY
		=with_return_endwith()
	CATCH TO oErreur
		cMessage1 = m.oErreur.MESSAGE
	ENDTRY
	cMessage = UPPER("Test utilisation RETURN  l'intrieur d'une affectation de proprites par WITH .. ENDWITH:") + m._CRLF + m._CRLF + m.cMessage1
	? "Test utilisation d'un RETURN dans un WITH ENDWITH fin :" + TTOC(DATETIME())
	=MESSAGEBOX(m.cMessage, 0+64, 'AtoutFox2019', m.iDelaiMessage)
	CLEAR
	* CONCLUSION
	************
	* Il semble qu'un RETURN lors de l'utilisation du WITH .. ENDWITH ne gnre pas de problme particulier malgr ce qui est indiqu dans le manuel utilisateur de Foxpro car corrig dans le drenier service pack
ENDPROC

PROCEDURE with_return_endwith
	*!*	1 - Dclarer un objet  l'identique du premier et affecter chaque proprites d'un objet dans un WITH .. ENDWITH. Boucler 1000 fois pour ce test
	=SYS(1104) && garbage collector
	LOCAL oObjet AS OBJECT;
		, iBoucle AS INTEGER;
		, i AS INTEGER

	iBoucle = 100000
	* Initialisation d' objet contenant chacun 15 proprites
	oObjet = NEWOBJECT('empty')
	FOR i = 1 TO 5
		=ADDPROPERTY(m.oObjet,'cvar' + ALLTRIM(STR(m.i)), '')
	ENDFOR
	FOR i = 1 TO 5
		=ADDPROPERTY(m.oObjet,'ivar' + ALLTRIM(STR(m.i)), 0)
	ENDFOR
	FOR i = 1 TO 5
		=ADDPROPERTY(m.oObjet,'lvar' + ALLTRIM(STR(m.i)), .F.)
	ENDFOR
	* Affectation
	FOR i = 1 TO m.iBoucle
		WITH oObjet
			.cVar1 = PADR('ma propriet objet.cvar1' + ' ' + ALLTRIM(STR(m.i)), 40, SPACE(1))
			.cVar2 = PADR('ma propriet objet.cvar2' + ' ' + ALLTRIM(STR(m.i)), 40, SPACE(1))
			.cVar3 = PADR('ma propriet objet.cvar3' + ' ' + ALLTRIM(STR(m.i)), 40, SPACE(1))
			.cVar4 = PADR('ma propriet objet.cvar4' + ' ' + ALLTRIM(STR(m.i)), 40, SPACE(1))
			.cvar5 = PADR('ma propriet objet.cvar5' + ' ' + ALLTRIM(STR(m.i)), 40, SPACE(1))
			.ivar1 = m.i
			.ivar2 = m.i + 1
			.ivar3 = m.i + 2
			.ivar4 = m.i + 3
			.ivar5 = m.i + 4
			IF m.i = 10000
				RETURN .F.
			ENDIF
			.lvar1 = .T.
			.lvar2 = .F.
			.lvar3 = .T.
			.lvar4 = .F.
			.lvar5 = .T.
		ENDWITH
	ENDFOR
ENDPROC

PROCEDURE test_type_versus_vartype
	*!*	1 - Dclarer un objet oObjet  et y affecter une proprit boolenne lActif
	*!* 2 - Dans une boucle faire excuter cType = TYPE('oObjet') et en mesurer le temps d'excution
	*!* 3 - Dans une seconde boucle faire excuter cType = VARTYPE(m.oObjet)et en mesurer le temps d'excution
	=SYS(1104) && garbage collector
	? "Test d'utilisation de VARTYPE() versus TYPE() pour valuer le type d'un objet dbut :" + TTOC(DATETIME())
	LOCAL cMessage AS STRING;
		, cType AS CHARACTER;
		, cMessage1 AS STRING;
		, cMessage2 AS STRING;
		, oObjet AS OBJECT;
		, cFileCoverage AS STRING;
		, iDuree1 AS NUMBER;
		, iDuree2 AS NUMBER;
		, iBoucle AS INTEGER;
		, i AS INTEGER

	iBoucle = 10000
	STORE '' TO cMessage1, cMessage2, cType
	STORE 0 TO iDureeInstruction1, iDureeInstruction2, iDuree1, iDuree2
	* Initialisation d' objet contenant une proprit boolenne lActif
	oObjet = NEWOBJECT('empty')
	=ADDPROPERTY(m.oObjet,'lActif', .T.)

	FOR i = 1 TO m.iBoucle
		* Test utilisation VARTYPE()
		=QueryPerformanceCounter(@m.iDureeInstruction1)
		cType = VARTYPE(m.oObjet.lactif)
		=QueryPerformanceCounter(@m.iDureeInstruction2)
		iDuree1 = m.iDuree1 + (m.iDureeInstruction2 - m.iDureeInstruction1)

		* Test utilisation TYPE()
		=QueryPerformanceCounter(@m.iDureeInstruction1)
		cType = TYPE('oObjet.lactif')
		=QueryPerformanceCounter(@m.iDureeInstruction2)
		iDuree2 = m.iDuree2 + (m.iDureeInstruction2 - m.iDureeInstruction1)
	ENDFOR
	cMessage1 = "Dure valuation VARTYPE(m.oObjet.lactif): " + ALLTRIM(STR(m.iDuree1 / m.iBoucle, 10, 3)) + ' s' + m._CRLF
	cMessage2 = "Dure valuation TYPE('oObjet.lactif') : " + ALLTRIM(STR(m.iDuree2 / m.iBoucle, 10, 3)) + ' s' + m._CRLF

	cMessage = UPPER("Test d'utilisation TYPE() versus VARTYPE():") + m._CRLF + m._CRLF + m.cMessage1 + m._CRLF + m._CRLF + m.cMessage2
	? "Test d'utilisation de VARTYPE() versus TYPE() pour valuer le type d'un objet fin :" + TTOC(DATETIME())
	=MESSAGEBOX(m.cMessage, 0+64, 'AtoutFox2019', m.iDelaiMessage)
	CLEAR
	* CONCLUSION
	************
	* VARTYPE() ne peut pas tre utilis dans une mthode, vnement ou procdure si le test porte sur la proprit d'un objet enfant d'un autre objet (object de second niveau) et que ladite proprit n'existe pass car cela gnre une erreur VFP
	* VARTYPE() est un beaucoup plus rapide que TYPE() entre 50et 90% plus rapide.
ENDPROC